function [npic] = NombredePics(s,f0,Fe,seuil,BW)
%NombredePics	Dtection du nombre de pics d'un signal
%
%	[npic] = NombredePics(s,f0,Fe,seuil,BW) repre les pics
%	d'un signal situ au-dessus d'un certain seuil, par
%	intercorrlation avec une fonction peigne d'impulsion 
%	gaussienne de mme largeur que le signal s, de frquence f0
%	et de largeur de bande BW (BW exprim en %. Plus BW
%	est petit, plus la largeur de bande sera grande
%   BW = 10 -> largeur  mi-hauteur de 8% de la priode
%   BW = 20 -> largeur  mi-hauteur de 4% de la priode)

%	Auteur : Nathalie Henrich, 04/08/00.
%	$Rvision: 


d0 = Fe/f0;
ind = min(find(s == max(s)));  
indpos = fix((ind/d0-fix(ind/d0))*d0 - d0/2);

% gnration d'un train d'impulsion gaussienne
% de largeur de bande BW : 
% t = 0:1/Fe:2/f0;
% ygauss = exp(-t.^2 * (pi/2)^2 / (-(1/BW/f0)^2*log(10^(-6/20)))).*cos(2*pi*f0*t);

T=0:1/Fe:length(s)/Fe;
D=indpos/Fe:1/f0:length(s)/Fe;

y=pulstran(T,D,'gauspuls',f0,BW);

% intercorrlation entre le train d'impulsion 
% et le signal s
N = length(s);
interc = xcorr(y,s); % DIVA
interc = interc(N : 2*N-1);

% slection d'une priode sur le signal
% d'intercorrlation
indmax = find(interc(1:min([fix(3*d0/2) length(interc)])) == max(interc(1:min([fix(3*d0/2) length(interc)]))));

if indmax<d0/2
   intercsel = interc(indmax+fix(d0/2):min(N,indmax+fix(3*d0/2)));
else
   intercsel = interc(max(1,indmax-fix(d0/2)):min(N,indmax+fix(d0/2)));
end

% dtection des pics du signal
if fix(seuil*3/2) >= length(intercsel)
seuil
figure(3)
plot(intercsel)
waitforbuttonpress
    seuil = length(intercsel);
end

[valpic,indpic]	=	PicDetect(intercsel,seuil);

% nombre de pics dtects
npic = length(indpic);

