function [y,f]=spectre(x,Fe,Nfft,a)
% spectre
% [y,f]=spectre (x,Fe,Nfft,a) calcule le spectre 
% d'un signal x connaissant Fe.
% Le spectre est normalis par un facteur d'amplitude length(x)/2,
% afin de prendre en compte l'influence du fentrage (fentre rectangulaire).
%
% Si on ne prcise pas Nfft, la valeur par dfaut est choisie
% comme la puissance de 2 immdiatement suprieure  la taille de s.
% Le paramtre a dcide si on reprsente la totalit du spectre
% ou juste une des deux parties symtriques.
% Si a n'est pas prcis, on ne reprsente qu'une partie

% auteur : Nathalie Henrich, 11/08/00
%
%   $Revision: 19/10/00

x = x(:);

% valeur de Nfft par dfaut
if nargin<3
   N = length(x);
   k = 0;
   while N>=1
      N = N / 2;
      k = k+1;
   end
   Nfft = 2^(k);
end      


if nargin<4
   y=fft(x,2*Nfft);
   y=y(1:fix(length(y)/2));
   f=(0:length(y)-1)*Fe/2/length(y);
      
else
   y=fft(x,Nfft);
   f=(0:length(y)-1)*Fe/length(y);
   
end

   % prise en compte de la fentre rectangulaire
   y = y/length(x);
